#include <SoftwareSerial.h>
#include <Wire.h>
#include <Adafruit_PWMServoDriver.h>

SoftwareSerial _bt_device(2,4);
unsigned long previousMillis = 0;
int _bt_cmd=0;

Adafruit_PWMServoDriver pwm = Adafruit_PWMServoDriver();

int servo1Pin = 0; // Conecta el servo1 al canal 0 del módulo PCA9685
int servo2Pin = 1; // Conecta el servo2 al canal 1 del módulo PCA9685
int servo3Pin = 2; // Conecta el servo3 al canal 2 del módulo PCA9685

/***   Function declaration   ***/
void LEDMatrix_init(int cs, int din, int clk);
void writeRow(int cs, int din, int clk, int row, int data);
void maxAll (int cs, int din, int clk, int reg, int col);
void putByte (int din, int clk, int data);
void expression(int cs, int din, int clk, int col1, int col2, int col3, int col4, int col5, int col6, int col7, int col8);

void setup() {
  Wire.begin();
  pwm.begin();
  pwm.setPWMFreq(50);  // Establece la frecuencia del módulo PCA9685 a 50Hz

 pinMode(12,OUTPUT);
  pinMode(13,OUTPUT);
  pinMode(11,OUTPUT);

  maxAll(12,13,11,11,7);
  maxAll(12,13,11,9,0);
  maxAll(12,13,11,12,1);
  maxAll(12,13,11,15,0);
  int i=0;
  for (i = 1; i <= 8; i++)
	maxAll(12,13,11,i,0);
  maxAll(12,13,11,10,15);
  _bt_device.begin(9600);
  _bt_device.flush();
  String name = "Capitán Olimar";
  String str = "AT\r\nAT\r\nAT+NAME"+name+"\r\n";
  _bt_device.write(str.c_str());
  Serial.begin(9600);    // Inicia la comunicación serial a 9600 bps
}

void loop() {

  if (_bt_device.available()>0  || _bt_cmd>0){
      
      int cmd=_bt_device.read();
        Serial.println((char)(cmd+48-100));
      if ((cmd==100)||(_bt_cmd==100)){
          //STOP
        setServoPosition(servo1Pin, 90);
        setServoPosition(servo2Pin, 90);
    	  }
      if ((cmd==101)||(_bt_cmd==101)){
          //Right
        setServoPosition(servo1Pin, 90);
        setServoPosition(servo2Pin, 180);
    	  }
      if ((cmd==102)||(_bt_cmd==102)){
          //Left
        setServoPosition(servo1Pin, 0);
        setServoPosition(servo2Pin, 90);
    	  }
      if ((cmd==103)||(_bt_cmd==103)){
          //Back
        setServoPosition(servo1Pin, 180);
        setServoPosition(servo2Pin, 0);
    	  }
      if ((cmd==104)||(_bt_cmd==104)){
          //Forward
        setServoPosition(servo1Pin, 0);
        setServoPosition(servo2Pin, 180);
    	  }
      if ((cmd==105)||(_bt_cmd==105)){
        // Gira el servo3 a 180 grados
        setServoPosition(servo3Pin, 180);
        // Cara ataque
        expression(12,13,11,153,60,90,255,255,90,60,153);
        delay(200);
        setServoPosition(servo3Pin, 90);
    	}
    }else{
        //setServoPosition(servo1Pin, 90);
        //setServoPosition(servo2Pin, 90);
    }
}
/***   Function definition   ***/
void LEDMatrix_init(int cs, int din, int clk) {
maxAll(cs,din,clk,11,7);
maxAll(cs,din,clk,9,0);
maxAll(cs,din,clk,12,1);
maxAll(cs,din,clk,15,0);
int i=0;
for (i = 1; i <= 8; i++) {
maxAll(cs,din,clk,i, 0);
}
maxAll(cs,din,clk,10,15);
}
void writeRow(int cs, int din, int clk, int row, int data) {
digitalWrite(cs,LOW);
putByte(din,clk,row);
putByte(din,clk,data);
digitalWrite(cs,LOW);
digitalWrite(cs,HIGH);
}
void maxAll (int cs, int din, int clk, int reg, int col) {
digitalWrite(cs,LOW);
putByte(din,clk,reg);
putByte(din,clk,col);
digitalWrite(cs,LOW);
digitalWrite(cs,HIGH);
}
void putByte (int din, int clk, int data) {
byte i = 8;
byte mask;
while(i > 0) {mask = 0x01 << (i - 1);
	digitalWrite(clk,LOW);
	if (data & mask)
{
	  digitalWrite(din,HIGH);
	}else{
	  digitalWrite(din,LOW);
	}
	digitalWrite(clk,HIGH);
	--i;
}
}

void setServoPosition(int servoPin, int angle) {
  int pulse = map(angle, 0, 180, 102, 512);  // Mapea el ángulo a un valor de pulso entre 102 y 512
  pwm.setPWM(servoPin, 0, pulse);  // Establece el pulso correspondiente al ángulo en el canal del módulo PCA9685
}
void expression(int cs, int din, int clk, int col1, int col2, int col3, int col4, int col5, int col6, int col7, int col8) {
writeRow(cs,din,clk,1, col1);
writeRow(cs,din,clk,2, col2);
writeRow(cs,din,clk,3, col3);
writeRow(cs,din,clk,4, col4);
writeRow(cs,din,clk,5, col5);
writeRow(cs,din,clk,6, col6);
writeRow(cs,din,clk,7, col7);
writeRow(cs,din,clk,8, col8);
}
