const int triggerPin = 9;  // Pin digital al que está conectado el pin TRIGGER del sensor ultrasonido
const int echoPin = 10;    // Pin digital al que está conectado el pin ECHO del sensor ultrasonido

void setup() {
  Serial.begin(9600);  // Inicia la comunicación serial a 9600 bps
  pinMode(triggerPin, OUTPUT);  // Configura el pin TRIGGER como salida
  pinMode(echoPin, INPUT);      // Configura el pin ECHO como entrada
}

void loop() {
  // Envía un pulso de ultrasonido
  digitalWrite(triggerPin, LOW);
  delayMicroseconds(2);
  digitalWrite(triggerPin, HIGH);
  delayMicroseconds(10);
  digitalWrite(triggerPin, LOW);

  // Mide el tiempo de eco del pulso
  long duration = pulseIn(echoPin, HIGH);

  // Calcula la distancia en centímetros
  float distance = duration * 0.034 / 2;

  // Muestra la distancia en el monitor serie
  Serial.print("Distancia: ");
  Serial.print(distance);
  Serial.println(" cm");

  delay(1000);  // Espera 1 segundo antes de realizar la siguiente medición
}
